ClassToolHandler = class(Turbine.UI.Control)
function ClassToolHandler:Constructor()
    Turbine.UI.Control.Constructor(self)
    if not(Settings.ClassToolsEnabled) then return end

    self.tool = nil

    self.playerClass = Turbine.Gameplay.LocalPlayer.GetInstance():GetClass()

    self.classSettings = LoadTable(Turbine.DataScope.Account, "PrimeClassTools")

    if self.classSettings == nil then self.classSettings = {} end

    if self.playerClass == Turbine.Gameplay.Class.Beorning then

        self.tool = BeorningTools(self.classSettings[self.playerClass])

    elseif self.playerClass == Turbine.Gameplay.Class.Brawler then

    elseif self.playerClass == Turbine.Gameplay.Class.Burglar then 

    elseif self.playerClass == Turbine.Gameplay.Class.Champion then

    elseif self.playerClass == Turbine.Gameplay.Class.Captain then

    elseif self.playerClass == Turbine.Gameplay.Class.Guardian then

        if Roles:GetLine() == 1 then self.tool = GuardianTools(self.classSettings[self.playerClass]) end

    elseif self.playerClass == Turbine.Gameplay.Class.Hunter then

        self.tool = HunterTools(self.classSettings[self.playerClass])
        
    elseif self.playerClass == Turbine.Gameplay.Class.LoreMaster then

    elseif self.playerClass == Turbine.Gameplay.Class.Minstrel then

    elseif self.playerClass == Turbine.Gameplay.Class.RuneKeeper then

    elseif self.playerClass == Turbine.Gameplay.Class.Warden then
        
        self.tool = WardenTools(self.classSettings[self.playerClass])

    end

    self.Update = function()
        if Turbine.Engine.GetGameTime() > self.reloadTime then
            self:ReloadTool()
            self:SetWantsUpdates(false)
        end
    end
end

function ClassToolHandler:CheckForTools()
    if self.tool then return self.tool else return false end
end

function ClassToolHandler:Unload()

    if self.tool then
        self.tool:RemoveCallbacks()
        Settings.ClassToolsX, Settings.ClassToolsY = self.tool:GetPosition()
        self.classSettings[self.playerClass] = self.tool:GetData()
        SaveTable(Turbine.DataScope.Account, "PrimeClassTools", self.classSettings)
    end
    
end

function ClassToolHandler:CheckClass()
    if self.playerClass == Turbine.Gameplay.Class.Beorning then

        return true

    elseif self.playerClass == Turbine.Gameplay.Class.Brawler then

    elseif self.playerClass == Turbine.Gameplay.Class.Burglar then 

    elseif self.playerClass == Turbine.Gameplay.Class.Champion then

    elseif self.playerClass == Turbine.Gameplay.Class.Captain then

    elseif self.playerClass == Turbine.Gameplay.Class.Guardian then

        if Roles:GetLine() == 1 then return true else return false end

    elseif self.playerClass == Turbine.Gameplay.Class.Hunter then

        return true
        
    elseif self.playerClass == Turbine.Gameplay.Class.LoreMaster then

    elseif self.playerClass == Turbine.Gameplay.Class.Minstrel then

    elseif self.playerClass == Turbine.Gameplay.Class.RuneKeeper then

    elseif self.playerClass == Turbine.Gameplay.Class.Warden then
        
        return true

    end

    return false
end

function ClassToolHandler:ReloadTool()
    if self.tool then
        if self:CheckClass() then
            self.tool:Reload()
        else
            self.tool:Unload()
        end
    end
end

function ClassToolHandler:ReloadToolWithDelay()
    self.reloadTime = Turbine.Engine.GetGameTime() + 5
    self:SetWantsUpdates(true)
end

function ClassToolHandler:ToggleMove()
    if self.tool then self.tool:ToggleMove() end
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

ClassToolsOptions = class(Turbine.UI.Control)
function ClassToolsOptions:Constructor(parent)
    local width = 750
    local height = 500
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10 - 2, 10 - 2)
    SingleBackground:SetSize(730 + 4, 450 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10, 10)
    SingleBackground:SetSize(730, 450)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local EffectBox = Turbine.UI.Lotro.CheckBox();
    EffectBox:SetParent(SingleBackground)
    EffectBox:SetPosition(10, 10);
    EffectBox:SetSize(200,20);
    EffectBox:SetChecked(Settings.ClassToolsEnabled)
    EffectBox:SetText("Class Tools Enabled");
    EffectBox:SetVisible(true);

    EffectBox.CheckedChanged = function()
        Settings.ClassToolsEnabled = EffectBox:IsChecked()
        MasterOptions:ChangesMade()
    end

    self.moveButton = Turbine.UI.Lotro.Button()
    self.moveButton:SetParent(SingleBackground)
    self.moveButton:SetText("Move")
    self.moveButton:SetPosition(210, 10)
    self.moveButton.Click = function()
        ClassTools:ToggleMove()
    end

    local container = Turbine.UI.ListBox()
    container:SetParent(SingleBackground)
    container:SetSize(700, 240)
    container:SetPosition(10, 30)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)
    --container:SetBackColor(GetRandomColour())

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar();
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    containerScrollbar:SetParent( SingleBackground );
    containerScrollbar:SetPosition( 780 - 10, 10 );
    containerScrollbar:SetSize( 10, 400 );
    container:SetVerticalScrollBar( containerScrollbar );

    self.createSkillBar = function(name, load, x, y)

        local pluginBar = Turbine.UI.Control()
        pluginBar:SetSize(800, 40)
        pluginBar:SetBackColor(Turbine.UI.Color(0, 0, 0))

        local backgroundBar = Turbine.UI.Control()
        backgroundBar:SetSize(800, 38)
        backgroundBar:SetPosition(0, 1)
        backgroundBar:SetParent(pluginBar)
        backgroundBar:SetMouseVisible(false)
        backgroundBar:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
        --pluginBar:SetBackColor(GetRandomColour())

        local nameLabel = Turbine.UI.Label()
        nameLabel:SetParent(pluginBar)
        nameLabel:SetSize(200, 20)
        nameLabel:SetPosition(0, 10)
        nameLabel:SetMouseVisible(false)
        nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
        nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        nameLabel:SetMultiline(false)
        nameLabel:SetText(name)

        local EffectBox = Turbine.UI.Lotro.CheckBox();
        EffectBox:SetParent(pluginBar)
        EffectBox:SetPosition(160, 10);
        EffectBox:SetSize(120,20);
        EffectBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        EffectBox:SetChecked(load)
        EffectBox:SetText("Load");
        EffectBox:SetVisible(true);

        local ScaleLabel = Turbine.UI.Label()
        ScaleLabel:SetParent(pluginBar)
        ScaleLabel:SetSize(200, 30)
        ScaleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
        ScaleLabel:SetPosition(230, 10)
        ScaleLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        ScaleLabel:SetText("X-axis priority") 
    
        local BarScaleBar = Turbine.UI.Lotro.TextBox()
        BarScaleBar:SetParent(pluginBar)
        BarScaleBar:SetSize(50, 30)
        BarScaleBar:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        BarScaleBar:SetPosition(340, 5)
        BarScaleBar:SetText(x)

        local ScaleLabel = Turbine.UI.Label()
        ScaleLabel:SetParent(pluginBar)
        ScaleLabel:SetSize(200, 30)
        ScaleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
        ScaleLabel:SetPosition(400, 10)
        ScaleLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        ScaleLabel:SetText("Y-axis") 
    
        local BarScaleBar2 = Turbine.UI.Lotro.TextBox()
        BarScaleBar2:SetParent(pluginBar)
        BarScaleBar2:SetSize(50, 30)
        BarScaleBar2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        BarScaleBar2:SetPosition(450, 5)
        BarScaleBar2:SetText(y)

        local Button2 = Turbine.UI.Lotro.Button()
        Button2:SetParent(pluginBar)
        Button2:SetSize(80, 20)
        Button2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        Button2:SetMouseVisible(true)
        Button2:SetPosition(620, 10)
        Button2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        Button2:SetText("Save")

        Button2.Click = function()
            self.tool:ChangeData(name, {EffectBox:IsChecked(), tonumber(BarScaleBar:GetText()), tonumber(BarScaleBar2:GetText())})
        end



        return pluginBar
    end

    self.tool = ClassTools:CheckForTools()
    if not(self.tool) then return end

    for key, value in spairs(self.tool:GetData(), 
    function(t,a,b) 
        if t[a][3] < t[b][3] then
            return true
        elseif t[a][3] > t[b][3] then
            return false
        elseif t[a][3] == t[b][3] then
            return t[a][2] < t[b][2] 
        end
    end) do container:AddItem(self.createSkillBar(key, value[1], value[2], value[3])) end

    if self.tool then self.specificOptions = self.tool:GetOptions(self, 110, 300) end

end